/*
    ES Knot
    Copyright 2005, 2006 Martin Storsjo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsjo
    martin@martin.st
*/

#ifndef __KNOTAPPVIEW_H
#define __KNOTAPPVIEW_H

#ifdef USE_OES_2
#include <EGL/egl.h>
#else
#include <GLES/egl.h>
#endif
#include <coecntrl.h>
#include "glappview.h"

class Knot;

class CKnotAppView : public CGLAppView {
public:

#ifdef UIQ3
	static CKnotAppView* NewL(CQikAppUi& aAppUi);
	static CKnotAppView* NewLC(CQikAppUi& aAppUi);
	TVwsViewId ViewId() const;
	TInt ViewConfigurationId() const;
#else
	static CKnotAppView* NewL(const TRect& aRect);
	static CKnotAppView* NewLC(const TRect& aRect);
#endif
	~CKnotAppView();

	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);
	void HandlePointerEventL(const TPointerEvent& aPointerEvent);

	void SizeChanged();

protected:
	void DeinitGC();
	void InitGC();
	void ConstructAppL();
	void ReinitApp();
	void UpdateAndDraw();
	void FPSUpdated();
	void AppClearContext();

private:
#ifdef UIQ3
	CKnotAppView(CQikAppUi& aAppUi);
#else
	CKnotAppView();
#endif

	const CFont* iFont;
	TPoint iLastPos;
	TInt iDistance;


public:
	Knot* iKnot;
};

#endif
