#!/bin/sh

if [ $# -lt 3 ]; then
	echo "$0 bundle certname profilename"
	exit 1
fi

BUNDLE=$1
CERT=$2
PROFILE=$3

PLATFORM=/Developer/Platforms/iPhoneOS.platform/Developer
SDK=$PLATFORM/SDKs/iPhoneOS2.0.sdk
PATH=$PLATFORM/usr/bin:$PATH

# if $BUNDLE starts with /
if [ "`echo $BUNDLE | grep ^/`" != ""  ] ; then
	BUNDLEFULL=$BUNDLE
else
	BUNDLEFULL=`pwd`/$BUNDLE
fi

cp $SDK/ResourceRules.plist "$BUNDLE"
defaults write "$BUNDLEFULL"/Info CFBundleResourceSpecification -string ResourceRules.plist
#defaults write "$BUNDLEFULL"/Info DTPlatformName -string iphoneos
#defaults write "$BUNDLEFULL"/Info DTSDKName -string '(SDK_NAME)'

for i in ~/Library/MobileDevice/Provisioning\ Profiles/*.mobileprovision; do
	grep "$PROFILE" "$i" > /dev/null
	if [ $? -eq 0 ]; then
		cp "$i" "$BUNDLE"/embedded.mobileprovision
	fi
done
PROVISION=`pwd`/provision
openssl smime -verify -in "$BUNDLE"/embedded.mobileprovision -inform DER -noverify > "$PROVISION".plist
PREFIX=`defaults read "$PROVISION" ApplicationIdentifierPrefix | grep "    " | sed "s/    //"`
rm "$PROVISION".plist
IDENTIFIER=`defaults read "$BUNDLEFULL"/Info CFBundleIdentifier`
./gen_entitlements.py $PREFIX.$IDENTIFIER tmp.xcent

chmod a+r "$BUNDLE"/Info.plist
iphoneos-optimize "$BUNDLEFULL"
CODESIGN_ALLOCATE=$PLATFORM/usr/bin/codesign_allocate codesign -f -s "$CERT" --resource-rules="$BUNDLE"/ResourceRules.plist --entitlements tmp.xcent "$BUNDLE"
rm tmp.xcent


