/*
    ES Knot
    Copyright 2005, 2006 Martin Storsjo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsjo
    martin@martin.st
*/

#include "window.h"
#ifdef USE_OES_2
#include "knot2.h"
#include <GLES2/gl2.h>
#else
#include "knot.h"
#include <GLES/gl.h>
#endif
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>

#define WIDTH 176
#define HEIGHT 208

void debug(const char* str) {
	printf("%s\n", str);
}

int main(int argc, char *argv[]) {
	int width = WIDTH, height = HEIGHT;
	createEGLWindow(&width, &height, "ESKnot");

	printf("vendor: %s\n", glGetString(GL_VENDOR));
	printf("renderer: %s\n", glGetString(GL_RENDERER));
	printf("version: %s\n", glGetString(GL_VERSION));
	printf("extensions: %s\n", glGetString(GL_EXTENSIONS));

	Knot *k = new Knot(width, height);
//	k->setTexMode(Knot::UNTEXTURED);
/*
	k->draw(0);
	k->draw(0);
	glFlush();
	postEGLWindow();
	usleep(1000*2000);
*/
	unsigned int lastMorphStart = (unsigned int) -1;
	while (1) {
		struct timeval tv;
		gettimeofday(&tv, NULL);
		unsigned int msec = tv.tv_sec*1000 + tv.tv_usec/1000;
		k->draw(msec);
		glFlush();
		postEGLWindow();
		usleep(1000*5);
		if (lastMorphStart == (unsigned int)-1)
			lastMorphStart = msec - 3000;
		if (msec - lastMorphStart > 4000) {
			k->startMorph();
			lastMorphStart = msec;
		}
	}
	delete k;
	return 0;
}

